//-----------------------------------------------------------------------------
// Title      : bsp_ub046_mk3_timer2
//-----------------------------------------------------------------------------
// Funktion   : Timer Test2
// Schaltung  : myAVR MK3
//-----------------------------------------------------------------------------
// Prozessor  : ATMega2560
// Takt       : 16 MHz
// Sprache    : C
// Date       : 31.05.2012
// Version    : 1.0
// Autor      : UB
//-----------------------------------------------------------------------------
#define F_CPU 16000000
#include <avr/io.h>
#include <ub_mk3_2560/MK3_2560_TIMER.h>
#include <ub_mk3_2560/MK3_2560_LED.h>
#include <ub_mk3_2560/MK3_2560_ADC.h>



//-----------------------------------------------------------------------------
// Hinweis : Quick-Jumper Port-L muss gesetzt sein
// - Poti muss an Port-F0 angeschlossen sein
// - benutzt Timer Funktion zur Zeitmessung und fuer Wartezeiten
// - Es wird im wechsel der Poti-Wert fr 5 sek an den LEDs angezeigt
//   und dann blinken die LEDs 10 mal
//-----------------------------------------------------------------------------
int main (void)
{
    unsigned int ad_wert=0;
    unsigned char mode=0,n;
    
    MK3_INIT_TIMER();				// init vom Timer
	MK3_INIT_LED();                 // Init der LEDs
	MK3_INIT_ADC();                 // Init vom AD-Wandler
	
    
    mode=0; // mit Mode_0 beginnen
    while (true)
    {
      if(mode==0) {
        // Mode=0 -> Timer mit 5 sek starten
        MK3_TIMER_START_S(5);
        while(MK3_TIMER_CHECK()==false) {
          // 5sek lang den ADC-Wert
          // an den LEDs anzeigen
          ad_wert=MK3_ADC_READ_CH(ADC0);
          MK3_LED_ZAHL(ad_wert/4);
        }
        // auf Mode-1 umschalten
        mode=1;
      }
      else if(mode==1) {
        // Mode=1 -> LEDs 10mal blinken lassen
        for(n=0;n<10;n++) {
          MK3_LED_TOGGLE(LED_ALL);
          MK3_WAIT_MS(500);       // 500 ms warten
        }
        // auf Mode_0 umschalten
        mode=0;
      }
    }
    return 0;
}
//-----------------------------------------------------------------------------
